#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>


FILE* settingsfile;

char settingsfilename[1024];
char chfilename[1024];
char outdirname[1024];
char appdirname[1024];
char leafname[512];
char timestring[64];
char chn;
char channel_name[128];
char spaced_name[128];

int lcn[20];

char commandstring[1024];

long i,istop,ok,nchannels,n,go,rtime_secs,rtime_mins;


time_t t;
struct tm *tmp;

long read_settingsfile(void);
void make_recording(void);

int main(int argc, char* argv[])
{
  
  printf(" DVB recorder V1.01 Jim Lesurf 2nd Oct 2012\n");
  printf(" ==========================================\n\n");
  i=argc;
  printf("Number of arguments given = %ld\n\n",i);
  sprintf(appdirname,"%s\0",argv[0]);
  ok=(long)strrchr(appdirname,'/')-(long)appdirname;
  appdirname[ok]=(char)0;
  printf("Application directory = %s\n",appdirname);
  sprintf(settingsfilename,"%s/%s\0",appdirname,"Settings\0");
  printf("Settings file at %s\n\n",settingsfilename);
  
  read_settingsfile();
  go=1;
  while(go==1)
  {
    make_recording();
    printf("Recording done. Press:\n  1 to restart recording\n  0 to quit recording\n followed by <return>\n => ");
    scanf("%ld",&go);
  }
  
  printf("  *Done!* ");
  return 0;
}

void make_recording(void)
{
  
  
  printf("Enter channel name * * USING UNDERSCORES AS SPACES! * *\n\n => ");
  
  scanf("%s",channel_name);
  i=0; istop=0;
  do
  {
    chn=channel_name[i];
    if (14>(int)chn)
    {
      istop=1;
      spaced_name[i]=(char)0;
    }
    
    if(istop==0)
    {
      if(chn=='_')
      {
        chn=' ';
      }
      
      spaced_name[i]=chn;
      i++;
    }
  } while (istop==0);
    
   printf("%s = %s\n",channel_name,spaced_name);
   
   printf("Type in duration of recording [mins] (0 means until quit)\n => ");
   scanf("%ld",&rtime_mins);
   
   t=time(NULL);
   tmp=localtime(&t);
   strftime(timestring,sizeof(timestring),"%a%d%b%Hh%Mm%Ss\0",tmp);
   printf("Time = %s\n",timestring);
   
   if (rtime_mins==0)
   {
     printf("Recording will continue until halted by a <ctrl>-C\n");
     sprintf(commandstring,"tzap -rpc %s '%s' -o %s/%s_%s.ts\n",chfilename,spaced_name,outdirname,channel_name,timestring);
     printf("Command is\n = %s",commandstring);
   }
   else
   {
     rtime_secs=60*rtime_mins;
     printf("Recording will halt after %ld sec [ %ld mins]\n",rtime_secs,rtime_mins);
     sprintf(commandstring,"tzap -rpc %s '%s' -t %ld -o %s/%s_%s.ts\n",chfilename,spaced_name,rtime_secs,outdirname,channel_name,timestring);
     printf("Command is\n = %s",commandstring);
   }
    
   system(commandstring);
  
}


long read_settingsfile(void)
{
  long result;

  settingsfile=fopen(settingsfilename,"rt");
  
  fscanf(settingsfile,"%s",leafname);
  sprintf(chfilename,"%s/ChannelLists/%s\0",appdirname,leafname);
  printf("Channel list used\n = %s\n\n",chfilename);
  
  fscanf(settingsfile,"%s",outdirname);
  printf("Output directory for recordings\n = %s\n\n",outdirname);
  
  fclose(settingsfile);
  result=1;
  return result;
}








